# Generated by Django 4.2.16 on 2024-09-26 14:54

from django.db import migrations, models
from reversion.models import Version
from reversion import  create_revision

def fix_constraints(apps, schema_editor):
    LessonDocumentation = apps.get_model("alsijil", "LessonDocumentation")
    PersonalNote = apps.get_model("alsijil", "PersonalNote")

    with create_revision():
        personal_notes = PersonalNote.objects.filter(extra_lesson_id__isnull=False).values("extra_lesson_id", "person_id", "week", "year").annotate(count=models.Count("id")).filter(count__gt=1)


        for personal_note in personal_notes:
            affected_entries = PersonalNote.objects.filter(extra_lesson_id=personal_note["extra_lesson_id"], person_id=personal_note["person_id"])
            current_date = None
            newest = None
            for affected_entry in affected_entries:
                versions = Version.objects.get_for_object(affected_entry)
                if not versions:
                    if not newest:
                        newest = affected_entry
                    continue
                version = versions[0]
                if not current_date or version.revision.date_created > current_date:
                    current_date = version.revision.date_created
                    newest = affected_entry

            affected_entries.exclude(pk=newest.pk).delete()

        personal_notes = PersonalNote.objects.filter(event_id__isnull=False).values("event_id", "person_id", "week", "year").annotate(count=models.Count("id")).filter(count__gt=1)

        for personal_note in personal_notes:
            affected_entries = PersonalNote.objects.filter(event_id=personal_note["event_id"], person_id=personal_note["person_id"])
            current_date = None
            newest = None
            for affected_entry in affected_entries:
                versions = Version.objects.get_for_object(affected_entry)
                if not versions:
                    if not newest:
                        newest = affected_entry
                    continue
                version = versions[0]
                if not current_date or version.revision.date_created > current_date:
                    current_date = version.revision.date_created
                    newest = affected_entry

            affected_entries.exclude(pk=newest.pk).delete()

        lesson_documentations = LessonDocumentation.objects.filter(extra_lesson_id__isnull=False).values("extra_lesson_id", "week", "year").annotate(count=models.Count("id")).filter(count__gt=1)

        for lesson_documentation in lesson_documentations:
            affected_entries = LessonDocumentation.objects.filter(extra_lesson_id=lesson_documentation["extra_lesson_id"])
            current_date = None
            newest = None
            for affected_entry in affected_entries:
                versions = Version.objects.get_for_object(affected_entry)
                if not versions:
                    if not newest:
                        newest = affected_entry
                    continue
                version = versions[0]
                if not current_date or version.revision.date_created > current_date:
                    current_date = version.revision.date_created
                    newest = affected_entry

            affected_entries.exclude(pk=newest.pk).delete()


        lesson_documentations = LessonDocumentation.objects.filter(event_id__isnull=False).values("event_id", "week", "year").annotate(count=models.Count("id")).filter(count__gt=1)

        for lesson_documentation in lesson_documentations:
            affected_entries = LessonDocumentation.objects.filter(event_id=lesson_documentation["event_id"])
            current_date = None
            newest = None
            for affected_entry in affected_entries:
                versions = Version.objects.get_for_object(affected_entry)
                if not versions:
                    if not newest:
                        newest = affected_entry
                    continue
                version = versions[0]
                if not current_date or version.revision.date_created > current_date:
                    current_date = version.revision.date_created
                    newest = affected_entry

            affected_entries.exclude(pk=newest.pk).delete()

class Migration(migrations.Migration):

    dependencies = [
        ("alsijil", "0017_rename_late_to_tardiness"),
    ]

    operations = [
        migrations.RunPython(fix_constraints),
    ]
